<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Product } from '@/types/Product'
import { useProductStore } from '@/stores/product'
import { useTypeStore } from '@/stores/type'
const productStore = useProductStore()
const typeStore = useTypeStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await productStore.deleteProduct()
  closeDelete()
}
async function editItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialog.value = true
}
async function deleteItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await typeStore.getTypes()
})
</script>
<template>
  <div id="app" class="d-flex justify-center">
    <v-card
      variant="tonal"
      width="100%"
      min-width="500"
      max-width="1200"
      max-height="600"
      min-height="750"
      class="ma-3 bg-teal-darken-4"
      :elevation="18"
    >
      <v-card variant="tonal" class="ma-2 bg-teal-darken-4">
        <div
          style="
            background-color: rgb(0, 0, 0);
            color: aliceblue;
            text-align: center;
            font-size: 50px;
            font-family: Arial, Helvetica, sans-serif;
          "
        >
          Product
        </div>
        <v-container>
          <div class="d-flex justify-center">
            <v-card min-width="500" max-width="1200" height="auto" elevation="6">
              <v-table fixed-header height="550px" style="overflow: auto; width: 2000px">
                <thead>
                  <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">Image</th>
                    <th class="text-center">Name</th>
                    <th class="text-center">Price</th>
                    <th class="text-center">Type</th>
                    <th class="text-center">subType</th>
                    <th class="text-center">Size</th>
                    <th class="text-center">SweetLevel</th>
                    <th class="text-center"></th>
                    <!-- <th class="text-center"></th> -->
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in productStore.products" :key="item.id">
                    <td class="text-center">{{ item.id }}</td>
                    <td class="text-center">
                      <v-img
                        :src="'http://localhost:3000/images/products/' + item.image"
                        width="100"
                        height="100"
                        class="mx-auto"
                        align="center"
                      ></v-img>
                    </td>
                    <td class="text-center">
                      {{ item.name.length > 20 ? item.name.slice(0, 20) + '...' : item.name }}
                    </td>
                    <td class="text-center">{{ item.price }}</td>
                    <td class="text-center">{{ item.type.name }}</td>
                    <td class="text-center">{{ item.subType }}</td>
                    <td class="text-center">{{ item.size }}</td>
                    <td class="text-center">{{ item.sweetLevel }}</td>
                    <!-- <td class="text-center">{{ item.amount }}</td> -->
                    <td class="text-center">
                      <v-btn
                        class="mx-2"
                        icon="mdi-pencil"
                        density="compact"
                        color="light-green-darken-3"
                        @click="editItem(item)"
                      >
                      </v-btn>
                      <v-btn
                        icon="mdi-trash-can"
                        density="compact"
                        color="deep-orange-darken-4"
                        @click="
                          () => {
                            deleteItem(item)
                          }
                        "
                      ></v-btn>
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-card>
          </div>
        </v-container>
      </v-card>
      <v-btn
        class="mt-3"
        v-bind:style="{ alignSelf: 'flex-end', marginLeft: '87%' }"
        color="green-darken-3"
        id="AddProduct"
      >
        Add Product
      </v-btn>
    </v-card>
  </div>
  <v-dialog v-model="dialog" persistent width="1024" activator="#AddProduct">
    <v-card>
      <v-card-title>
        <span class="text-h5">Product Form</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="productStore.editedProduct.name"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Name"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-text-field
                  v-model.number="productStore.editedProduct.price"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Price"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6">
                <v-combobox
                  v-model="productStore.editedProduct.type"
                  :items="typeStore.type"
                  key="id"
                  item-title="name"
                  item-value="id"
                  label="Select type"
                  :return-object="true"
                ></v-combobox>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-autocomplete
                  v-model="productStore.editedProduct.subType"
                  :items="['Hot', 'Cool', 'Frappe', '-']"
                  label="Select SubType"
                  multiple
                ></v-autocomplete>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-autocomplete
                  v-model="productStore.editedProduct.size"
                  :items="['S', 'M', 'L', '-']"
                  label="Select SubType"
                  multiple
                ></v-autocomplete>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-autocomplete
                  v-model="productStore.editedProduct.sweetLevel"
                  :items="['0%', '25%', '50%', '75%', '100%', '-']"
                  label="Select SubType"
                  multiple
                ></v-autocomplete>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-img
                  :src="'http://localhost:3000/images/products/' + productStore.editedProduct.image"
                  width="200"
                ></v-img>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-file-input
                  v-model="productStore.editedProduct.files"
                  :rules="[
                    (value) => {
                      return (
                        !value ||
                        !value.length ||
                        value[0].size < 2000000 ||
                        'Avatar size should be less than 2 MB!'
                      )
                    }
                  ]"
                  accept="image/png, image/jpeg, image/bmp"
                  placeholder="Pick an avatar"
                  prepend-icon="mdi-camera"
                  label="Image"
                ></v-file-input>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDelete()">Cancel</v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm()">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style scoped>
#app {
  background-color: #212121;
  height: 100%;
}
</style>
